=== debian/changelog ===
kokkos (5.0.1-1) experimental; urgency=medium

  * New upstream version.
  * d/copyright: bump years.
  * d/watch: update to version 5.

 -- Alex Myczko <tar@debian.org>  Wed, 07 Jan 2026 16:22:11 +0100
