## kokkos 5.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -141,7 +141,7 @@
 
 set(Kokkos_VERSION_MAJOR 5)
 set(Kokkos_VERSION_MINOR 0)
-set(Kokkos_VERSION_PATCH 1)
+set(Kokkos_VERSION_PATCH 2)
 set(Kokkos_VERSION "${Kokkos_VERSION_MAJOR}.${Kokkos_VERSION_MINOR}.${Kokkos_VERSION_PATCH}")
 message(STATUS "Kokkos version: ${Kokkos_VERSION}")
 math(EXPR KOKKOS_VERSION "${Kokkos_VERSION_MAJOR} * 10000 + ${Kokkos_VERSION_MINOR} * 100 + ${Kokkos_VERSION_PATCH}")
