=== debian/changelog ===
kokkos (5.0.2-2) unstable; urgency=medium

  * Bump standards version to 4.7.3.
  * d/control: drop Rules-Requires-Root.

 -- Alex Myczko <tar@debian.org>  Sun, 01 Mar 2026 12:52:36 +0100

kokkos (5.0.2-1) experimental; urgency=medium

  * New upstream verison.

 -- Alex Myczko <tar@debian.org>  Sat, 07 Feb 2026 18:38:49 +0100
